module contmod
    implicit none
    private
    public::operator(<),content

    type name
        character(15)::nname=" ",vname=" "
    end type

    type datum
        integer::d=0,m=0,y=0
    end type

    type content
        type(name)::nam
        type(datum)::dat
    end type

    interface operator (<)
        module procedure klnam,kldat
    end interface

    contains

    logical function klnam(a,b)
        type(name),intent(in)::a,b
        !klnam=a%nname<b%nname.or.a%nname=b%nname.and.a%vname<b%vname
        klnam=a%nname<b%nname
        if(a%nname==b%nname)then
            klnam=a%vname<b%vname
        end if

    end function

    logical function kldat(a,b)
        type(datum),intent(in)::a,b
        !kldat=a%y<b%y.or.a%y=b%y.and.(a%m<b%m.or.a%m=b%m.and.a%d<b%d)
        kldat=a%y<b%y
        if(a%y==b%y)then
            kldat=a%m<b%m
            if(a%m==b%m)then
                kldat=a%d<b%d
            end if
        end if

    end function

end module

module listmod
    use contmod
    implicit none
    private
    public::liste,makelist,writelist

    type elem
        type(content)::cont
        type(elem),pointer::nextdat=>null(),nextnam=>null()
        type(elem),pointer::prevdat=>null(),prevnam=>null()
    end type

    type liste
        type(elem),pointer::headdat=>null(),headnam=>null()
        !type(elem),pointer::taildat=>null(),tailnam=>null()
    end type

    contains

    subroutine makelist(l,c)
        type(liste)::l
        type(content)::hilf
        character(*)::c
        integer::ios

        open(unit=33,file=c,action="read",iostat=ios,status="old")
        if(ios/=0)then
            write(*,*)"Fehler"
            stop
        end if
        do
            read(33,*,iostat=ios)hilf
            if(ios/=0)exit
            call insert(l,hilf)
        end do
        close(33)

    end subroutine

    subroutine insert(l,c)
        type(liste)::l
        type(content)::c
        type(elem),pointer::hilf


        allocate(hilf)
        hilf%cont=c
        IF(.not.associated(l%headnam))THEN !das erste Element muss eingefügt werden
          l%headdat=>hilf
          l%headnam=>hilf
        ELSE
          !nach NAMEN
          IF(c%nam<l%headnam%cont%nam)THEN !vor dem ersten Element muss eingefügt werden
            hilf%nextnam=>l%headnam
            l%headnam%prevnam=>hilf
            l%headnam=>hilf
          ELSE
            hilf%nextnam=>l%headnam%nextnam !hilfspointer
            hilf%prevnam=>l%headnam
            DO
              IF(.not.associated(hilf%nextnam))THEN !das Ende ist erreicht
                hilf%prevnam%nextnam=>hilf
                EXIT
              ELSE IF(c%nam<hilf%nextnam%cont%nam)THEN !Position zum einfügen gefunden
                hilf%prevnam%nextnam=>hilf
                hilf%nextnam%prevnam=>hilf
                exit
              ELSE
                hilf%prevnam=>hilf%nextnam !weitersetzen der Pointer
                hilf%nextnam=>hilf%nextnam%nextnam
              END IF
            END DO
          END IF

          !nach DATUM
          if(c%dat<l%headdat%cont%dat)then
              hilf%nextdat=>l%headdat
              l%headdat%prevdat=>hilf
              l%headdat=>hilf
          else
              hilf%nextdat=>l%headdat%nextdat
              hilf%prevdat=>l%headdat
              do
                  if(.not.associated(hilf%nextdat))then
                      hilf%prevdat%nextdat=>hilf
                      !l%taildat=>hilf
                      exit
                  else if(c%dat<hilf%nextdat%cont%dat)then
                      hilf%prevdat%nextdat=>hilf
                      hilf%nextdat%prevdat=>hilf
                      exit
                  else
                      hilf%prevdat=>hilf%nextdat
                      hilf%nextdat=>hilf%nextdat%nextdat
                  end if
              end do
          end if
        END IF

    end subroutine

    subroutine writelist(l)
        type(liste)::l
        type(elem),pointer::hilf
        character::a

        do
            write(*,*)"nach Namen(n) oder nach Datum(d)?"
            read(*,*)a
            if(a=="n".or.a=="d")exit
            write(*,*)"Eingabefehler"
        end do

        if(a=="n")then
          call listebynam(l)
        else
          call listebydat(l)
        end if

    end subroutine

    subroutine listebydat(l)
        type(liste)::l
        type(elem),POINTER::hilf

        IF(.not.associated(l%headdat))THEN
          WRITE(*,*)"die liste ist leer"
        ELSE
          hilf=>l%headdat
          DO
            write(*,*)hilf%cont
            hilf=>hilf%nextdat
            IF(.not.associated(hilf))exit
          END DO
        END IF

    end subroutine

    subroutine listebynam(l)
        type(liste)::l
        type(elem),POINTER::hilf

        IF(.not.associated(l%headnam))THEN
          WRITE(*,*)"die liste ist leer"
        ELSE
          hilf=>l%headnam
          DO
            write(*,*)hilf%cont
            hilf=>hilf%nextnam
            IF(.not.associated(hilf))exit
          END DO
      END IF
    end subroutine

    !subroutine deleteliste(l)

end module

program listsort
    use listmod
    implicit none

    character(len=15)::c
    type(liste)::l

    c="leute.dat"
    call makelist(l,trim(c))
    call writelist(l)
    !delteliste

end program
